package client.gui.character;

import client.gui.element.ActButton;
import client.gui.element.ActButton.Mode;
import client.gui.element.GuiList;
import client.gui.element.ListEntry;
import client.gui.element.NavButton;
import client.renderer.Drawing;
import common.packet.CPacketAction;

public class GuiClass extends GuiList<GuiClass.ClassEntry> implements ActButton.Callback
{
	protected class ClassEntry implements ListEntry
	{
		private final Enum clazz;
		
	    protected ClassEntry(Enum clazz)
	    {
	    	this.clazz = clazz;
	    }

	    public void draw(int x, int y, int mouseX, int mouseY, boolean hovered)
	    {
	    	if(GuiClass.this.gm.thePlayer != null && this.clazz == GuiClass.this.gm.thePlayer.getNpcClass())
	    		Drawing.drawRect(x, y, 1, 44, 0xffaf0000);
            Drawing.drawText(this.clazz.toString().isEmpty() ? "<Keine>" : this.clazz.toString(), x + 3, y, 0xffffffff);
	    }
	    
	    public void select(boolean dclick, int mx, int my)
	    {
	    	if((GuiClass.this.selectButton.enabled = GuiClass.this.gm.thePlayer == null || this.clazz != GuiClass.this.gm.thePlayer.getNpcClass()) && dclick)
	    		GuiClass.this.use(GuiClass.this.selectButton, Mode.PRIMARY);
	    }
	}

	public static final GuiClass INSTANCE = new GuiClass();
	
	private ActButton selectButton;
	
    private GuiClass() {
    }
    
    public void init(int width, int height)
    {
    	super.init(width, height);
        this.setDimensions(400, height, 32, height - 32);
        this.elements.clear();
        if(this.gm.thePlayer != null && this.gm.thePlayer.getSpecies().classEnum != null)
	        for(Enum clazz : this.gm.thePlayer.getSpecies().classEnum.getEnumConstants()) {
	        	this.elements.add(new ClassEntry(clazz));
	        }
        this.add(new NavButton(width - 198 * 2, height - 28, 194, 24, GuiChar.INSTANCE, "Zurück"));
        this.selectButton = this.add(new ActButton(width - 198, height - 28, 194, 24, this, "Klasse ändern"));
    }
        
	public String getTitle() {
		return "Klasse wählen";
	}
	
    public int getListWidth()
    {
        return 400 - 20;
    }
    
    public int getSlotHeight()
    {
        return 44 + 4;
    }

	public void use(ActButton elem, Mode action) {
		ClassEntry entry = this.getSelected();
		if(entry != null && GuiClass.this.gm.thePlayer != null) {
			GuiClass.this.gm.thePlayer.sendQueue.addToSendQueue(new CPacketAction(CPacketAction.Action.SET_CLASS, entry.clazz.ordinal()));
			this.gm.displayGuiScreen(GuiChar.INSTANCE);
		}
	}
}
