package common;

import common.entity.Entity;
import common.entity.npc.EntityNPC;
import common.entity.types.IEntityFX;
import common.model.ParticleType;
import common.nbt.NBTTagCompound;
import common.sound.Sound;
import common.util.BlockPos;
import common.world.State;

public interface IClient {
	int getRenderDistance();
	float getGravity();
	int getTimeFactor();
	boolean hasDayCycle();
	void playSound(Sound sound);
	EntityNPC getPlayer();
	Entity getRenderViewEntity();
	void makeFireworks(double x, double y, double z, double motionX, double motionY, double motionZ, NBTTagCompound compund);
	IEntityFX spawnEffectParticle(int particleId, double xCoord, double yCoord, double zCoord, double xSpeed, double ySpeed, double zSpeed, int[] parameters);
	void addBlockDestroyEffects(BlockPos pos, State state);
	void sendBlockBreakProgress(int breakerId, BlockPos pos, int progress);
	void markBlocksForUpdate(int x1, int y1, int z1, int x2, int y2, int z2);
	void updatePlayerMoveState();
	void emitParticleAtEntity(Entity entityIn, ParticleType particleTypes);
	boolean isJumping();
	boolean isSprinting();
	boolean isSneaking();
	float getMoveForward();
	float getMoveStrafe();
	void setMoveForward(float value);
	void setMoveStrafe(float value);
}
