package common;

import java.util.List;
import java.util.Map;

import common.entity.Entity;
import common.entity.npc.EntityNPC;
import common.network.IPlayer;
import common.network.Packet;
import common.util.BlockPos;
import common.util.PortalType;
import common.util.Position;
import common.world.WorldServer;

public interface IServer {
	List<IPlayer> getIPlayers();
	void sendPacket(Packet packet);
	void sendPacket(Packet packet, int dimension);
	void sendNear(double x, double y, double z, double radius, int dimension, Packet packet);
	void sendNearExcept(EntityNPC except, double x, double y, double z, double radius, int dimension, Packet packet);
	Map<String, Position> getWarps();
	List<WorldServer> getWorlds();
	WorldServer getWorld(int dimension);
	void placeInDimension(Entity entity, WorldServer oldWorld, WorldServer world, BlockPos pos, PortalType portal);
}