package common.biome;

import common.init.Blocks;
import common.rng.Random;
import common.rng.WeightedList;
import common.util.BlockPos;
import common.world.WorldServer;
import common.worldgen.feature.WorldGenDesertWells;

public class BiomeDesert extends Biome
{
    public BiomeDesert(int id)
    {
        super(id);
        this.topBlock = Blocks.sand.getState();
        this.fillerBlock = Blocks.sand.getState();
        this.treesPerChunk = -999;
        this.deadBushPerChunk = 2;
        this.reedsPerChunk = 50;
        this.cactiPerChunk = 10;
        this.generateLakes = false;
    }
    
    protected void addMobs(WeightedList<RngSpawn> mobs) {
    }

    public void decorate(WorldServer worldIn, Random rand, BlockPos pos)
    {
        super.decorate(worldIn, rand, pos);

        if (rand.chance(1000))
        {
            int i = rand.chOffset();
            int j = rand.chOffset();
            BlockPos blockpos = worldIn.getHeight(pos.add(i, 0, j)).up();
            (new WorldGenDesertWells()).generate(worldIn, rand, blockpos);
        }
    }
}
