package common.biome;

import common.block.BlockDirt;
import common.init.Blocks;
import common.rng.Random;
import common.rng.WeightedList;
import common.util.BlockPos;
import common.world.WorldServer;
import common.worldgen.FeatureGenerator;
import common.worldgen.feature.WorldGenAsteroid;

public class BiomeSpace extends Biome
{
	protected FeatureGenerator asteroidGen1 = new WorldGenAsteroid(Blocks.stone.getState(), 
			Blocks.rock.getState());
	protected FeatureGenerator asteroidGen2 = new WorldGenAsteroid(Blocks.dirt.getState(), 
			Blocks.dirt.getState().withProperty(BlockDirt.VARIANT, BlockDirt.DirtType.COARSE_DIRT));
	
    public BiomeSpace(int id)
    {
        super(id);
        this.topBlock = Blocks.air.getState();
        this.fillerBlock = Blocks.air.getState();
    }
    
    protected void addMobs(WeightedList<RngSpawn> mobs) {
    }

    public void decorate(WorldServer worldIn, Random rand, BlockPos pos)
    {
		if(rand.chance(5)) {
			int x = rand.chOffset();
			int z = rand.chOffset();
			rand.chance(this.asteroidGen1, this.asteroidGen2, 100).generate(worldIn, rand,
					pos.add(x, rand.range(16, 495), z));
		}
    }
}
