package common.biome;

public enum Scaling {
    VARYING_LOW(0.1F, 0.2F),
    VARYING_MEDIUM(0.1F, 1.0F),
    VARYING_CHAOTIC(1.0F, 2.0F),
    SEA_VARYING(0.1F, 0.8F),
    SEA_SHORE(0.0F, 0.025F),
    SEA_POND(-0.2F, 0.1F),
    SEA_SHALLOW(-0.5F, 0.0F),
    SEA_MEDIUM(-1.0F, 0.1F),
    SEA_DEEP(-1.8F, 0.1F),
    PLAINS_LOW(0.125F, 0.05F),
    PLAINS_MEDIUM(0.2F, 0.2F),
    PLAINS_VARYING(0.2F, 0.3F),
    HILLS_LOW(0.45F, 0.3F),
    HILLS_MEDIUM(0.8F, 0.3F),
    HILLS_LARGE(1.0F, 0.5F),
    HILLS_PLATEAU(1.5F, 0.025F);
	
	public final float depth;
	public final float scale;

	private Scaling(float depth, float scale) {
		this.depth = depth;
		this.scale = scale;
	}
}
