package common.worldgen;

import common.biome.Biome;
import common.rng.PerlinGen;
import common.rng.Random;
import common.world.WorldServer;

public class ReplacerBiome implements BlockReplacer
{
    private final PerlinGen stoneNoiseGen;
    private final double[] stoneNoise = new double[256];
	
    public ReplacerBiome(Random rand)
    {
        this.stoneNoiseGen = new PerlinGen(rand, 4);
    }
    
    public void replaceBlocks(WorldServer world, int x, int z, ChunkPrimer primer, Random rand, Biome[] biomes)
    {
        double d0 = 0.03125D;
        this.stoneNoiseGen.generate(this.stoneNoise, (double)(x * 16), (double)(z * 16), 16, 16, d0 * 2.0D, d0 * 2.0D, 1.0D);

        for (int i = 0; i < 16; ++i)
        {
            for (int j = 0; j < 16; ++j)
            {
                Biome biome = biomes[j + i * 16];
                biome.genTerrainBlocks(world, rand, primer, x * 16 + i, z * 16 + j, this.stoneNoise[j + i * 16]);
            }
        }
    }
}
