package common.worldgen.feature;

import common.block.Block;
import common.init.Blocks;
import common.material.Material;
import common.rng.Random;
import common.util.BlockPos;
import common.world.WorldServer;
import common.worldgen.FeatureGenerator;

public class WorldGenHellLava extends FeatureGenerator
{
    private final Block field_150553_a;
    private final boolean field_94524_b;

    public WorldGenHellLava(Block p_i45453_1_, boolean p_i45453_2_)
    {
        this.field_150553_a = p_i45453_1_;
        this.field_94524_b = p_i45453_2_;
    }

    public boolean generate(WorldServer worldIn, Random rand, BlockPos position)
    {
        if (worldIn.getState(position.up()).getBlock() != Blocks.hellrock)
        {
            return false;
        }
        else if (worldIn.getState(position).getBlock().getMaterial() != Material.air && worldIn.getState(position).getBlock() != Blocks.hellrock)
        {
            return false;
        }
        else
        {
            int i = 0;

            if (worldIn.getState(position.west()).getBlock() == Blocks.hellrock)
            {
                ++i;
            }

            if (worldIn.getState(position.east()).getBlock() == Blocks.hellrock)
            {
                ++i;
            }

            if (worldIn.getState(position.north()).getBlock() == Blocks.hellrock)
            {
                ++i;
            }

            if (worldIn.getState(position.south()).getBlock() == Blocks.hellrock)
            {
                ++i;
            }

            if (worldIn.getState(position.down()).getBlock() == Blocks.hellrock)
            {
                ++i;
            }

            int j = 0;

            if (worldIn.isAirBlock(position.west()))
            {
                ++j;
            }

            if (worldIn.isAirBlock(position.east()))
            {
                ++j;
            }

            if (worldIn.isAirBlock(position.north()))
            {
                ++j;
            }

            if (worldIn.isAirBlock(position.south()))
            {
                ++j;
            }

            if (worldIn.isAirBlock(position.down()))
            {
                ++j;
            }

            if (!this.field_94524_b && i == 4 && j == 1 || i == 5)
            {
                worldIn.setState(position, this.field_150553_a.getState(), 2);
                worldIn.forceBlockUpdateTick(this.field_150553_a, position, rand);
            }

            return true;
        }
    }
}
