package common.worldgen.foliage;

import common.block.BlockDoublePlant;
import common.init.Blocks;
import common.rng.Random;
import common.util.BlockPos;
import common.world.WorldServer;

public class FeatureDoublePlant
{
    private BlockDoublePlant.EnumPlantType type;

    public void setPlantType(BlockDoublePlant.EnumPlantType type)
    {
        this.type = type;
    }

    public boolean generate(WorldServer worldIn, Random rand, BlockPos position)
    {
        boolean flag = false;

        for (int i = 0; i < 64; ++i)
        {
            BlockPos blockpos = position.add(rand.zrange(8) - rand.zrange(8), rand.zrange(4) - rand.zrange(4), rand.zrange(8) - rand.zrange(8));

            if (worldIn.isAirBlock(blockpos) && (!worldIn.dimension.hasNoLight() || blockpos.getY() < 254) && Blocks.double_plant.canPlaceBlockAt(worldIn, blockpos))
            {
                Blocks.double_plant.placeAt(worldIn, blockpos, this.type, 2);
                flag = true;
            }
        }

        return flag;
    }
}
