package server.command;

import common.entity.npc.EntityNPC;
import server.network.Player;

public class PlayerEntityParser extends PlayerParser {
	public PlayerEntityParser(String name, boolean useSender) {
		super(name, useSender);
	}

	public Object parse(CommandEnvironment env, String input) {
		Player net = (Player)super.parse(env, input);
		EntityNPC entity = net.getPresentEntity();
		if(entity == null)
			throw new RunException("Spieler-Objekt von '%s' wurde nicht gefunden", input);
		return entity;
	}
	
	public Object getDefault(CommandEnvironment env) {
		Player net = (Player)super.getDefault(env);
		return net == null ? null : net.getPresentEntity();
	}

	public Class<?> getTypeClass() {
		return EntityNPC.class;
	}
}
