package server.command;

import common.nbt.NBTException;
import common.nbt.NBTParser;
import common.nbt.NBTTagCompound;

public class TagParser extends DefaultingParser {
	public TagParser(String name, NBTTagCompound def, Object ... completions) {
		super(name, def, completions);
	}
	
	public NBTTagCompound parse(CommandEnvironment env, String input) {
		NBTTagCompound value;
		try {
			value = NBTParser.parseTag(input);
		}
		catch(NBTException e) {
			throw new RunException(e, "Ungültiger NBT-Tag '%s'", input);
		}
		return value;
	}

	public Class<?> getTypeClass() {
		return NBTTagCompound.class;
	}
}
