package server.command.commands;

import server.command.Command;
import server.command.CommandEnvironment;
import server.command.Executor;
import server.command.RunException;
import server.network.Player;

public class CommandRevoke extends Command {
	public CommandRevoke() {
		super("revoke");
		
		this.addPlayer("player", false);
	}
	
	public void exec(CommandEnvironment env, Executor exec, Player player) {
		if(exec instanceof Player)
			throw new RunException("Dieser Befehl kann nur der Konsole ausgeführt werden");
//		else if(player == exec)
//			throw new RunException("Du kannst nicht deinen eigenen Admin-Status entfernen");
		else if(!player.getAdmin())
			throw new RunException("%s ist kein Admin", player.getUser());
		player.setAdmin(false);
		player.logConsole("Der Host hat deine Administatorrechte entfernt");
		exec.logConsole("%s ist jetzt kein Admin mehr", player.getUser());
	}
}
