package server.command.commands;

import common.world.Weather;
import common.world.WorldServer;
import server.command.Command;
import server.command.CommandEnvironment;
import server.command.Executor;
import server.command.RunException;

public class CommandWeather extends Command {
	public CommandWeather() {
		super("weather");
		
		this.addEnum("weather", Weather.class, Weather.values());
		this.setParamsOptional();
		this.addWorld("dim", true);
		
		this.addFlag("transition", 't');
	}
	
	public void exec(CommandEnvironment env, Executor exec, Weather weather, WorldServer world, boolean transition) {
		if(!world.dimension.getType().weather)
			throw new RunException("Welt %s hat kein Wetter", world.dimension.getFormattedName(false));
		else if(world.isExterminated())
        	throw new RunException("Welt %s ist zerstört", world.dimension.getFormattedName(false));
    	world.setWeather(weather);
    	if(!transition)
    		world.resetWeather();
		exec.logConsole("Wetter in %s zu %s geändert", world.dimension.getFormattedName(false), weather.getDisplay());
	}
}
