package server.command.commands;

import java.util.List;

import common.entity.Entity;
import common.util.BlockPos;
import common.world.WorldServer;
import server.command.Command;
import server.command.CommandEnvironment;
import server.command.Executor;

public class CommandWorld extends Command {
	public CommandWorld() {
		super("world");

		this.addWorld("dim", true);
		
		this.addEntityList("entities", 'e', true);
	}
	
	public Object exec(CommandEnvironment env, Executor exec, WorldServer world, List<Entity> entities) {
		for(Entity entity : entities) {
			BlockPos pos = entity.getPosition();
			pos = pos.getY() < 0 ? new BlockPos(pos.getX(), 0, pos.getZ()) : pos;
	    	if(world.getState(pos).getBlock().getMaterial().blocksMovement() || world.getState(pos).getBlock().getMaterial().isLiquid()) {
		    	while((world.getState(pos).getBlock().getMaterial().blocksMovement() || world.getState(pos).getBlock().getMaterial().isLiquid()) && pos.getY() < 511)
		            pos = pos.up();
	    	}
	    	else {
	    		while(!(world.getState(pos).getBlock().getMaterial().blocksMovement() || world.getState(pos).getBlock().getMaterial().isLiquid()) && pos.getY() > 0)
		            pos = pos.down();
	    		pos = pos.up();
	    	}
	    	entity.teleport(pos, world.dimension.getDimensionId());
			exec.logConsole("%s nach %d, %d, %d in %s teleportiert", entity.getCommandName(), pos.getX(), pos.getY(), pos.getZ(), world.dimension.getFormattedName(false));
		}
		return entities.size();
	}
}
